/************************************************************************
*			WINFDEMO.C													*
*	"La mise en oeuvre facile des fentres de dialogue..."				*
*	par Jacques DELAVOIX	Janvier 1995								*
*	Modifications pour Windform 3.0 du 09/11/1996 par J. Delavoix.		*
*************************************************************************/

#include <stdlib.h>
#include <string.h>

#ifdef __SOZOBONX__
	#include <atari.h>	/* TOS  */
#else
	#include <tos.h>
#endif

#include "windform.h"
#include "winfdemo.h"

/*	Prototypes : */

void main(void);
void end_prog(void);
void init_prog(void);
void sauve_prefs(void);		/* NOUVEAU pour V 3.0	*/
void informe(int event);
void fiche_client(int event);
void color_window(int event);
void test_boutons(int event);
void desktop(int event);
int selecteur(void);
void window_texte(int event);
void open_text(void);
void close_text(void);
void redraw(int w_handle, int x, int y, int w, int h);
void sized(void);
void fulled(void);
void arrow(void);
void vslider(void);
void sliders(void);
void set_clip(int clip_flag, GRECT *area);

/* Attributs fentre principale */
#define wind_attr NAME|CLOSER|FULLER|MOVER|SIZER|UPARROW|DNARROW|VSLIDE|SMALLER

int ligne_0; 				/* 1 ligne de l'affichage */
int full_flag;
int h_ligne;				/* hauteur d'une ligne de texte	*/
int xf, yf, wf, hf; 		/* Coordonnes de la fentre texte */
int hauteur_totale = 50;	/* Hauteur totale en nbr. de lignes de texte*/
int text_handle;			/* handle fentre */
int couleur;				/* couleur de fond pour la fentre texte. */
int txt_iconified;			/* Icnification de la Fentre de Texte. */
char chemin[128];			/* "Chemin" pour "selecteur()"	*/
char filename[20];			/* Nom de fichier pour "selecteur()"	*/
OBJECT *adr_menu;			/* Adresse du menu */

WINDFORM_VAR infos_var;		/* Structures de variables pour form_windows */
WINDFORM_VAR client_var;
WINDFORM_VAR color_var;
WINDFORM_VAR boutons_var;

/************************************************************************/

void main(void)
{
	int quit = 0, event;
	init_prog();
	menu_icheck(adr_menu, DESK_FLG, desk_install(-1));
	menu_bar(adr_menu, 1);

	xf = x_desk + 4;	/* Coordonnes de dpart de la fentre */
	yf = y_desk + 40;
	wf = 328;
	hf = h_desk / 2;
	open_text();		/* Ouverture de la fentre de texte */

	color_window(OPEN_DIAL);
	fiche_client(OPEN_DIAL);
	test_boutons(OPEN_DIAL);
	graf_mouse(ARROW, 0);

	do		/* BOUCLE PRINCIPALE DU PROGRAMME */
	{
		event = get_evnt((MU_TIMER|MU_MESAG|MU_BUTTON|MU_KEYBD), 0L, 100);

		menu_keyshort(adr_menu, event, 0); /* Raccourcis Clavier des Menus. */

		if ((event & MU_MESAG) && buff[0] == MN_SELECTED)
		{
			switch (buff[4])
			{
			case INFOS :
				informe(OPEN_DIAL);
				break;
			case FICHE_CLI :
				fiche_client(OPEN_DIAL);
				break;
			case COLOR_WIND :
				color_window(OPEN_DIAL);
				break;
			case TST_BUTTONS :
				test_boutons(OPEN_DIAL);
				break;
			case OPENW :
				open_text();
				break;
			case QUITTER :
				quit = 1;
				break;
			case SAUVE_PREFS :
				sauve_prefs();
				break;
			case DESK_FLG :
				menu_icheck(adr_menu, DESK_FLG, desk_install(2));
				break;
			}
			menu_tnormal(adr_menu, buff[3], 1);
		}
		else
		{

/* *** Aiguillage en fonction du Handle : *** */

			if (buff[3] > 0)	/* Si W_Handle > 0 .... */
			{
				if (buff[3] == infos_var.w_handle)
					informe(event);
				else if (buff[3] == client_var.w_handle)
					fiche_client(event);
				else if (buff[3] == color_var.w_handle)
					color_window(event);
				else if (buff[3] == boutons_var.w_handle)
					test_boutons(event);
				else if (buff[3] == text_handle)
					window_texte(event);
			}
			else
				desktop(event); /*...sinon gestion d'un objet sur le Bureau.*/
		}
	} while (quit == 0);

/*	Avant de quitter, fermeture des fenres ventuellement ouvertes, on peut
aussi utiliser "wind_new()"	: */
	close_text();
	close_dialog(&infos_var);
	close_dialog(&client_var);
	close_dialog(&color_var);
	close_dialog(&boutons_var);

	menu_bar(adr_menu, 0);
	end_prog();
}

void end_prog(void)
{
	wind_set (0, WF_NEWDESK, 0, 0); /* A mettre en permanence. */
	v_clsvwk(vdi_handle);
	v_clsvwk(aes_handle);
	rsrc_free();
	appl_exit();
	exit(0);
}

/************************************************************************/
/*	Routine d'initialisations du programme :							*/
/************************************************************************/

void init_prog(void)
{
	init_gem(); /* Nouveau pour Version 3.0 */

/* hauteur des caractres + 1 pour viter que les lignes de textes
ne se touchent. */

	h_ligne = h_char + 1;

	get_prg_path("WINFDEMO.*");  /* Recherche rpertoire du Programme. */

	if (load_rsc("WINFDEMO.RSC", NO_WINDOW, ICONIF) == FALSE)
	{
		end_prog();
	}
	rsrc_gaddr(0, LE_MENU, &adr_menu);

	open_inf("WINFDEMO.INF", "r"); /* Ouverture des INF en Lecture.	*/

	init_windform(&infos_var, INFORME, 3, 400);
	init_windform(&client_var, FICHE_CLIENT, 640, 0);
	init_windform(&color_var, BACK_COLOR, 0, 0);
	init_windform(&boutons_var, BOUTONS, 10, 400);
	init_windesk(BUREAU);

	close_inf();

/* Exemple d'initialisations de champs de texte en dbut de programme : */

	reset_all_fields(&client_var);
}

void sauve_prefs(void)
{
	graf_mouse(BUSYBEE, 0);
	open_inf("WINFDEMO.INF", "w"); /* Ouverture des INF en Ecriture !	*/

	save_windform(&infos_var);
	save_windform(&client_var);
	save_windform(&color_var);
	save_windform(&boutons_var);
	save_windesk();

	close_inf();
	graf_mouse(ARROW, 0);
}

/************************************************************************/
/*	Quelques routines "Utilisateur" pour l'exemple :					*/
/************************************************************************/

void informe(int event)
{
	WINDFORM_VAR *ptr_var = &infos_var;
	int choix;

	if (event == OPEN_DIAL)
	{
		open_dialog(ptr_var, "Informations (Bloquant!)", 0, -1);
	}
	else
	{
		choix = windial_do(ptr_var, event);
		if (choix != 0)
		{
			if (choix == RETOUR)
			{
				wf_change(ptr_var, choix, NORMAL, 0);
			}
			else if(choix == B_BISTABLE)
				Cconout(7);					/* "Ping" */

/* Exemple des conditions de fermeture de la fentre : */
			if (choix != B_BISTABLE)
				close_dialog(ptr_var);
		}
	}
}

void fiche_client(int event)
{
	WINDFORM_VAR *ptr_var = &client_var;
	int choix, test;
	char essai[256];

	if (event == OPEN_DIAL)
	{
		open_dialog(ptr_var, "Fiche Client", NOM, TRUE);
	}
	else
	{
		choix = windform_do(ptr_var, event);
		if (choix != 0)
		{
			switch(choix)
			{
				case BUT_POP :
					test = pop_up(ptr_var, choix, POP_TEST);
					if (test > 0)
					{
						sprintf(essai, "%s%d%s", "[1][   WINFDEMO : | |"
							" Valeur retour Pop Up: ", test, "| ][ OK ]");
						form_alert(1, essai);
					}
					break;
				case CLIENT_ANNULE :
				case CLIENT_OK :
					wf_change(ptr_var, choix, NORMAL, 0);
				case CLOSE_DIAL :	/* Case de fermeture	*/
					close_dialog(ptr_var);
					break;
			}
		}
	}
}

void color_window(int event)
{
	WINDFORM_VAR *ptr_var = &color_var;
	int choix, mbuf[8];
	OBJECT *ptr_col = ptr_var->adr_form;

	if (event == OPEN_DIAL)	/* Partie "Ouverture : " */
	{
		/* Exemple d'initialisation avant chaque ouverture :  */
		if (ptr_var->w_handle == FALSE)	/* Test obligatoire ! */
		{
			reset_edit_field(ptr_var, COL_EDIT);
		}
		open_dialog(ptr_var, "Couleur fond de fentre", COL_EDIT, TRUE);
	}
	else		/* Sinon Partie "Gestion du dialogue" */
	{
		choix = windform_do(ptr_var, event);

		if (choix != 0)
		{
			if (choix == COL_APPLI)
				wf_change(ptr_var, choix, NORMAL, 1); /* avec Redessin */
			else if (choix > COL_EDIT)
				wf_change(ptr_var, choix, NORMAL, 0);
/* Une sortie par l'ditable ne produit pas de changement d'tats */

			if (choix < 0) /* Transforme le clic sur case fermeture (CLOSE_DIAL) */
				choix = COL_ANNULE;  /* en choix d'Annulation. */

			if (choix > COL_ANNULE) /* Action sur "Confirmer" */
			{
				couleur = get_rbutton(ptr_col, COL_0) - COL_0;
				if (text_handle)	/* si la fentre de texte est ouverte....*/
				{
					wind_get(0, WF_WORKXYWH, &mbuf[4], &mbuf[5], &mbuf[6], &mbuf[7]);
					/* envoi d'un message "WM_REDRAW"  cette fentre. */
					mbuf[0] = WM_REDRAW;
					mbuf[1] = app_id;
					mbuf[2] = 0;
					mbuf[3] = text_handle;
					appl_write(app_id, 16, mbuf);
				}
			}	/* Fin de l'action "Confirmer" */
			if (choix == COL_EDIT)
			{
				if (selecteur() != 0)
				{ /* Place la chaine dans l'editable et redessin : */
					set_editable(ptr_var, COL_EDIT, filename, TRUE);
				}
			}
			if (choix > COL_EDIT && choix < COL_APPLI)
				close_dialog(ptr_var); /* fermeture du dialogue */
		}
	/* Fin de "Gestion du dialogue" */
	}
}

void test_boutons(int event)
{
	WINDFORM_VAR *ptr_var = &boutons_var;
	int choix;

	if (event == OPEN_DIAL)
	{
		open_dialog(ptr_var, " Test Boutons", 0, 1);
	}
	else
	{
		choix = windform_do(ptr_var, event);
		if (choix != 0)
		{
			if (choix >= FCANCEL)
				wf_change(ptr_var, choix, NORMAL, 0);
			close_dialog(ptr_var);
		}
	}
}

void desktop(int event)
{
	char essai[256];
	int choix;

	choix = windesk_do(event);
	if (desk_icon_selected != 0)
	{
		if (choix == desk_icon_selected)
		{
			form_alert(1, "[1][ WINFDEMO : | |"
							" Double_clic sur l'Icone. ][ OK ]");
		}
		else if (choix != 0)
		{
			sprintf(essai, "%s %d%s %d%s", "[1][   WINFDEMO : | |"
				" DRAG & DROP| de l'Icone d'index :", desk_icon_selected,
				"|sur l'Icone d'index :", choix, "][ OK ]");
			form_alert(1, essai);
		}
	}
}

int selecteur()
{
	int button;
	get_curr_path(chemin);	/* fonction de Windform */
	fsel_exinput(chemin, filename, &button, "Choisissez un Fichier");
	if (button > 0 && strlen(filename) > 0)
		return TRUE;
	return FALSE;
}


/************************************************************************/
/*	et ensuite la gestion d'une fentre de texte classique :			*/
/************************************************************************/

void window_texte(int event)
{
	if (event & MU_MESAG)
	{
		switch(buff[0])
		{
			case WM_REDRAW :
				redraw(buff[3], buff[4], buff[5], buff[6], buff[7]);
				break;
			case WM_TOPPED :
				wind_set(buff[3], WF_TOP);
				break;
			case WM_CLOSED : 
				close_text();
				break;
			case WM_FULLED :
				fulled();
				break;
			case WM_ARROWED :
				arrow();
				break;
			case WM_VSLID :
				vslider();
				break;
			case WM_SIZED :
				sized();
				break;
			case WM_MOVED :
				wind_set(buff[3], WF_CURRXYWH, buff[4], buff[5], buff[6], buff[7]);
				xf = buff[4]; yf = buff[5]; /* mmoriser les nouvelles coordonnes */
				break;
			case WM_ICONIFY :
				iconify(text_handle, (GRECT*)(&buff[4]));
				txt_iconified = TRUE;
				break;				
			case WM_UNICONIFY :
				uniconify(text_handle, (GRECT*)(&buff[4]));
				txt_iconified = FALSE;
				break;
		}
	}
}

void open_text(void)
{
	if (text_handle > 0)				/* Si la fentre est dj ouverte */
		wind_set(text_handle, WF_TOP);	/* On la passe au premier plan */
	else
	{
		ligne_0 = 0;
		if ((text_handle = wind_create(wind_attr, x_desk, y_desk,
										w_desk, h_desk)) > 0)
		{
			wind_set(text_handle, WF_NAME, " Fentre de Texte ");
			wind_open(text_handle, xf, yf, wf, hf);
			sliders();					/* Position et taille du slider V */
		}
		else
		{
			form_alert(1, rsrc_get_string(NO_WINDOW));
		}
		txt_iconified = FALSE;
	}
}

void close_text(void)
{
	if (text_handle > 0)
	{
		wind_close(text_handle);
		wind_delete(text_handle);
		text_handle = 0;
	}
}

void redraw(int w_handle, int x, int y, int w, int h)
{
	GRECT r, rd;
	int xo, yo, wo, ho, xy[4];
	int i, y_base;
/*	char texte[80]; */
	rd.g_x = x;
	rd.g_y = y;
	rd.g_w = w;
	rd.g_h = h;
	wind_get(w_handle, WF_WORKXYWH, &xo, &yo, &wo, &ho);
	vst_color(vdi_handle, 2);
	vsf_color(vdi_handle, couleur);
	wind_update(BEG_UPDATE);
	wind_get(w_handle, WF_FIRSTXYWH, &r.g_x, &r.g_y, &r.g_w, &r.g_h);
	while (r.g_w && r.g_h)
	{
		if (rc_intersect(&rd, &r))
		{
			v_hide_c(vdi_handle);
			if (txt_iconified == TRUE) /* Si Icnifi . */
			{
				redraw_iconified(text_handle, &r);
			}
			else
			{
				set_clip(1, &r);
				y_base = yo + baseline + 1; /* Dbut de l'affichage en Y + 1 
pour viter que la premire ligne de texte ne touche le haut de la fentre. */
				xy[0] = r.g_x;
				xy[1] = r.g_y;
				xy[2] = xy[0]+r.g_w-1;
				xy[3] = xy[1]+r.g_h-1;
				vr_recfl(vdi_handle, xy);
				vswr_mode(vdi_handle, MD_TRANS);
				for (i = ligne_0; i <= 50; i++)
				{
/*					sprintf(texte, " Ligne %02d%s", i,
							" Test fentre de texte."); */
					v_gtext(vdi_handle, xo, y_base, " Bien lire la DOC est"
								" indispensable !");
					y_base += h_ligne; /* Prt pour ligne suivante. */
				}
				vswr_mode(vdi_handle, MD_REPLACE);
			}
			v_show_c(vdi_handle, 1);
		}
		wind_get(w_handle, WF_NEXTXYWH, &r.g_x, &r.g_y, &r.g_w, &r.g_h);
	}
	vst_color(vdi_handle, 1);
	wind_update(END_UPDATE);
}

void sized(void)
{
	wind_set(buff[3], WF_CURRXYWH, buff[4], buff[5], buff[6], buff[7]);
	full_flag = FALSE;		/* Annuler le flag de pleine ouverture */
	sliders();
	/* Enregistrer les coordonnes */
	wind_get(buff[3], WF_CURRXYWH, &xf, &yf, &wf, &hf);
}

void fulled(void)
{
	int x, y, w, h;
	int mode;
	if (full_flag)	/* Si elle est dj plein cran */
	{
		mode = WF_PREVXYWH;
		full_flag = FALSE;
	}
	else
	{
		mode = WF_FULLXYWH;
		full_flag = TRUE;
	}
	wind_get(buff[3], mode, &x, &y, &w, &h);
	wind_set(buff[3], WF_CURRXYWH, x, y, w, h);	/* Nouvelles coordonnes */
	/* Enregistrer les coordonnes */
	wind_get(buff[3], WF_CURRXYWH, &xf, &yf, &wf, &hf);
	sliders();	/* Ajuster tailles et positions sliders */
}

void arrow(void)
{
	int wx, wy, ww, wh;
	int action = FALSE, hauteur_page;

	wind_get(buff[3], WF_WORKXYWH, &wx, &wy, &ww, &wh);
	hauteur_page = wh / h_ligne;	/* Hauteur fentre en lignes de caractres */
	switch (buff[4])
	{
	case WA_UPPAGE :				/* Page vers le haut */
		if (ligne_0 > 0)
		{
			ligne_0 = max (ligne_0 - hauteur_page, 0);
			action = TRUE;
		}
		break;
	case WA_DNPAGE :				/* Page vers le bas */
		if ((ligne_0 + hauteur_page) < hauteur_totale)
		{
			ligne_0 = min (ligne_0 + hauteur_page, hauteur_totale - hauteur_page);
			action = TRUE;
		}
		break;
	case WA_UPLINE :				/* Ligne vers le haut */
		if (ligne_0 > 0)
		{
			ligne_0--;
			action = TRUE;
		}
		break;
	case WA_DNLINE :				/* Ligne vers le bas */
		if ((ligne_0 + hauteur_page) < hauteur_totale)
		{
			ligne_0++;
			action = TRUE;
		}
		break;
	}
	if (action)
	{
		sliders();
		redraw(text_handle, wx, wy, ww, wh);
	}
}

void vslider(void)
{
	int slide, wx, wy, ww, wh, hauteur_page;
	wind_get(buff[3], WF_WORKXYWH, &wx, &wy, &ww, &wh);
	slide = buff[4];
	hauteur_page = wh / h_ligne;	/* Hauteur en lignes de texte */
	ligne_0 = (int)((long)slide * (hauteur_totale - hauteur_page) / 1000);
	wind_set(buff[3], WF_VSLIDE, slide);
	redraw(text_handle, wx, wy, ww, wh);
}

/*	Taille et position slider V : */

void sliders(void)
{
	int wx, wy, ww, wh, hauteur_page;
	wind_get(text_handle, WF_WORKXYWH, &wx, &wy, &ww, &wh);
	hauteur_page = wh / h_ligne;
	/* Taille slider vertical */
	wind_set(text_handle, WF_VSLSIZE, (int)((1000L * hauteur_page)
										/ hauteur_totale));
	ligne_0 = min(ligne_0, hauteur_totale - hauteur_page);

	/* Position slider vertical */
	wind_set(text_handle, WF_VSLIDE, (int)((1000L * ligne_0)
			/ (hauteur_totale - hauteur_page)));
}

/***********************************************************************/

/*	Clipping :	*/

void set_clip(int clip_flag, GRECT *area)
{
	int pxy[4];
	pxy[0] = area->g_x;
	pxy[1] = area->g_y;
	pxy[2] = area->g_w + area->g_x - 1;
	pxy[3] = area->g_h + area->g_y - 1;
	vs_clip(vdi_handle, clip_flag, pxy);
}

