/****************************************************************************
*																			*
*	WINDFORM.H : Dfinitions utilises par les fonctions WIND_FORM.			*
*				 Modifications du 07/11/1996 pour Windform 3.0				*
*				 Par Jacques Delavoix.										*
* 			Corrections pour SozobonX par Olivier Booklage le 16/11/1996.	*
*																			*
*****************************************************************************/

#include <stdio.h>

#define min(A, B) ((A) < (B) ? (A) : (B))
#define max(A, B) ((A) > (B) ? (A) : (B))

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#ifndef ACTIVATOR
#define ACTIVATOR		0x600
#endif

#ifdef __SOZOBONX__
	#define aes_version global[0]
	#define number_apps global[1]
	#include <xgemfast.h>

  int	int_in[16]; /* Olivier Booklage. */
  int	int_out[7];
  void 	*addr_in[2];
  void 	*addr_out[2];/* le 16/11/1996. */

#else
	#define aes_version _GemParBlk.global[0]
	#define number_apps _GemParBlk.global[1]
	#include <aes.h>
	#include <vdi.h>
#endif

typedef struct
{
	OBJECT	*adr_form;	/* adresse du formulaire */
	int		w_handle;	/* Handle de fentre, est aussi tmoin d'ouverture. */
	int		w_x;		/* Coordonnes et dimensions de la fentre. */
	int		w_y;
	int		w_w;
	int		w_h;
	int		offset;		/* Dcalage x et y pour boite "OUTLINED". */
	int		edit_objc;	/* Objet ditable courant. */
	int		edit_pos;	/* Position courante du curseur d'dition. */
	char	reduced;	/* Flag de Rduction. (Rmi VANEL). */
	char	iconified;	/* Flag d'Icnification. (Olivier Booklage) */

} WINDFORM_VAR;

/* Attributs de la Fenetre de dialogue : */
extern int fw_attrib; /* NAME|CLOSER|MOVER|FULLER|SMALLER */

#define OPEN_DIAL	8192
#define CLOSE_DIAL	-1

#define NO_BISTABLE		(DEFAULT | EXIT | EDITABLE | RBUTTON)
#define SMALL_FLAG		0x400	/* Mini Bouton	*/
#define UNDER_B 18
#define SMALL_B 22

/* Dclarations des variables globales : */

extern int app_id, aes_handle, vdi_handle, baseline;
extern int x_desk, y_desk, w_desk, h_desk; /* Coordonnes du bureau */
extern int buff[8], mousex, mousey, mousek, key, key_s, nbr_clics;
extern int w_char, h_char;
extern int nb_planes;				/* Nombre de plans de couleurs.	*/
extern int color_3d1, color_3d2;	/* Couleurs pour la 3D */
extern int wtop;					/* fenetre actuellement active */
extern int modal_flag;				/* Mode Fentre Bloquante. */
extern FILE *fp_inf;				/* Pointeur de fichier pour .INF */
extern int desk_icon_selected;		/* Index de l'icne slectionn ou 0. */
extern char app_path[257];			/* Rpertoire de l'Application. */
extern WINDFORM_VAR desk_var;


/****************************************************************************
*	Fonctions d'Initialisations et Attente d'vnements :					*
*****************************************************************************/

void init_gem(void);
int load_rsc(char *rsc_name, int wind_fail, int index_icon);

int get_evnt(int flags, int *rect_area, int timer_lo);
int Get_Evnt(int flags, int timer_lo);		/* Voir la DOC. */

/****************************************************************************
*	Fonctions de Gestion des Fentres de Dialogue :							*
*****************************************************************************/

void init_windform(WINDFORM_VAR *ptr_var, int form_index, int pos_x, int pos_y);
void init_wform(WINDFORM_VAR * , int , int , int ); /* Voir la DOC. */
void open_dialog(WINDFORM_VAR *ptr, char *w_title, int edit_index, int back);
int windform_do(WINDFORM_VAR *ptr, int event);
int windial_do(WINDFORM_VAR *ptr_var, int event); /* Dialogue Bloquant */
void close_dialog(WINDFORM_VAR *ptr);

void wf_change(WINDFORM_VAR *ptr_var, int objet, int state, int flag);
/* remplace objc_change */
void wf_draw(WINDFORM_VAR *ptr_var, int objet);	/* remplace objc_draw */
void set_editable(WINDFORM_VAR *ptr_var, int index, char *string, int action);

/****************************************************************************
*	Fonctions de Gestion du Bureau :										*
*****************************************************************************/

void init_windesk(int desk_index); /* Initialise le Bureau */
int desk_install(int action); /* Installe/Dsinstalle le Bureau */
int windesk_do(int evnt); /* Gestion du Bureau... */
void desk_change(int objc, int state); /* Change l'tat d'un Objet */

/****************************************************************************
*	Fonctions Utilitaires sur fichier .INF	:								*
*****************************************************************************/

void get_prg_path(char *app_name);
void open_inf(char *filename, char *mode);
void read_inf_line(char *pattern, char *fmt, ...);
void write_inf_line(char *pattern, char *fmt, ...);
void save_windform(WINDFORM_VAR *ptr_var);
void save_windesk(void);
void close_inf(void);

/****************************************************************************
*	Gestion d'un Pop-up :													*
*****************************************************************************/

int pop_up(WINDFORM_VAR *ptr_var, int objc, int index);

/****************************************************************************
*	Autres fonctions utilitaires et diverses :								*
*****************************************************************************/

int objc_parent(OBJECT *tree, int index);
int get_rbutton(OBJECT *tree, int index);
void menu_keyshort(OBJECT *adr_menu, int evnt, int mode);
void init_radio(WINDFORM_VAR *ptr_var, int objet);
void reset_edit_field(WINDFORM_VAR *ptr_var, int object);
void reset_all_fields(WINDFORM_VAR *ptr_var);
char *strpcopy(char *dest, char *start, char *stop);
void get_curr_path(char *curr_path); /* Recherche du repertoire courant. */

#ifndef __SOZOBONX__
	int rc_intersect(GRECT *p1, GRECT *p2);
#endif

int stdkey(int key_code);
char *rsrc_get_string(int index);

/****************************************************************************
*	Fonctions d'Icnification, par Olivier Booklage. :						*
*****************************************************************************/

void iconify(int w_handle, GRECT *w);
void uniconify(int w_handle, GRECT *w);
void redraw_iconified(int w_handle, GRECT *zone);


/****************************************************************************
*	Fonctions prives, visibilit externe :									*
*	Routines de gestions des Boutons USERDEFS (raccourcis clavier)			*
*****************************************************************************/

int cdecl under_button(PARMBLK *parmblock);
void set_user(OBJECT *addr_tree);
void set_objc(OBJECT *addr_obj, int cdecl (*code)(PARMBLK *parmblock));

