/************************************************************************
*																		*
*		ACC_FORM.C	: Squelette pour la ralisation d'Accessoires		*
*					utilisant les routines WINDFORM.					*
*		Copyright (c) 17 Novembre 1996 par Delavoix Jacques.			*
*																		*
*	Modifs :															*
*																		*
*  le 12/04/1995 : Mise en conformit pour le fonctionnement en ACC		*
*  le 31/07/1995 : Retouches sur la prsentation et les commentaires.	*
*  le 17/11/1996 : Modifications pour WINDFORM 3.0						*
*																		*/
************************************************************************/

#include <stdlib.h>
#include "windform.h"
#include "acc_rsc.h"	/*  remplacer par le nom du Header de votre Ressource. */

/*	Dfinition des variables Globales.	*/

int	menu_id;		/* Identificateur menu. */

WINDFORM_VAR dialog_var;	/* Fentre de dialogue.	*/

/*	Prototypes de fonctions. */

void main(void);
int init_prog(void);			/* Initialisations du programme.	*/
void event_loop(void);			/* Boucle principale	*/
int utilisateur(int event);		/* Votre routine.....	*/

/* -------------------------------------------------------------------- */
/*	 main()	:															*/
/* -------------------------------------------------------------------- */

void main(void)
{
	int test;

	app_id = appl_init();	/* Handle d'application.	*/
	test = init_prog();
	if (test != 0 || _app == FALSE)	/* Si Initialisations russies OU Accessoire */
	{
		if (_app == FALSE && test != 0)	/* Si Accessoire ET Inits russies : */
			menu_id = menu_register(app_id, rsrc_get_string(ACC_TITLE));
		if (_app != 0)	/* Si lancement en programme...	*/
		{
			graf_mouse(ARROW, 0);
			utilisateur(OPEN_DIAL);
		}
		event_loop();			/* Boucle principale commune aux deux modes. */

		v_clsvwk(vdi_handle);	/* Retour en cas de lancement en programme. */
		rsrc_free();
	}
	appl_exit();
}

/* -------------------------------------------------------------------- */
/*	 init_prog() : Initialisations du programme.						*/
/* -------------------------------------------------------------------- */

int init_prog(void)
{
	init_gem();

	if (load_rsc("acc_rsc.rsc", NO_WINDOW, 0L) == 0) /*	Nom de votre Ressource.	*/
	{
		return FALSE;
	}

	init_windform(&dialog_var, INDEX, 0, 0);	/* INDEX de votre formulaire.	*/
	return TRUE;	/* Les initialisations ont russi.	*/
}

/* -------------------------------------------------------------------- */
/*	 event_loop()														*/
/* -------------------------------------------------------------------- */

void event_loop(void)
{
	int event, quit = 0;

	do
	{
		event = get_evnt(MU_MESAG | MU_BUTTON | MU_KEYBD, 0L, 10);

		if (event & MU_MESAG)
		{
			switch (buff[0])
			{
				case AC_OPEN:
					/*	if (buff[4] == menu_id)	*/
					utilisateur(OPEN_DIAL);
					event = FALSE;
					break;
				case AC_CLOSE:
					/*	if (buff[3] == menu_id)	*/
					dialog_var.w_handle = 0;
					event = FALSE;
			}
		}

		if (event)
		{
			if (buff[3] > 0)	/* Si W_Handle > 0 .... */
			{
				if (buff[3] == dialog_var.w_handle)
					quit = utilisateur(event);
				/* Mettre ici d'autres tests si d'autres fentres de prvues...	*/
			}
		}
	} while (quit == 0);
}

/* -------------------------------------------------------------------- */
/*	Routine "utilisateur()" :											*/
/* -------------------------------------------------------------------- */

int utilisateur(int event)
{
	WINDFORM_VAR *ptr_var = &dialog_var;
	int choix;

	if (event == OPEN_DIAL)
	{
		open_dialog(ptr_var, rsrc_get_string(WINDOW_TITLE), 0, 0);
	}
	else
	{
		choix = windform_do(ptr_var, event); /* Gestion du dialogue. */
		if (choix != 0)
		{
			if (choix > 0)	/* Remettre le bouton de sortie en NORMAL...*/
							/* ... ici, il est redessin (TRUE).		*/
				wf_change(ptr_var, choix, NORMAL, TRUE);

			if (choix == CLOSE_DIAL)
			{
				close_dialog(ptr_var);
				if (_app)
					return TRUE; /* Si lancement en programme. */
			}
		}
	}
	return FALSE;
}
