/*



 Base de travail pour un programme GEM utilisant Windform ( => 3.0 )

	V1.0 (C) Olivier Booklage

*/

/* #define	DESK	*/ /* Si utilisation du bureau */


#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef __SOZOBONX__
	#include <atari.h>
#else
	#include <tos.h>
#endif

#include <portab.h>
#include <windform.h>

/* ---       Includes internes       -- */

#include "base.h"	/* RSC index */

/* --- Constantes globales internes --- */

#define	RSC	"BASE.RSC"
#define PRG	"BASE.*"
#define INF	"BASE.INF"

/* --- Structures globales internes --- */

/* --- Variables globales  internes --- */

BYTE	version[]="V1.0";

#ifdef __SOZOBONX__
	BYTE	compilation[]="Compil avec "__VERSION__;
#else
	BYTE	compilation[]="Compil avec PureC 1.1";
#endif

OBJECT *adr_menu;			/* Adresse du menu */

WINDFORM_VAR info_var;		/* Structures de variables pour form_windows */
WINDFORM_VAR dial_var;

int quit = 0;							/* si==1 => Fin de programme */

/* ---     Prototypage interne      --- */

void main(void);
void end_prog(void);
void informe(int event);
void dialogue(int event);

void init_prog(void);
void sauve_prefs(void);

#ifdef DESK
void desktop(int event);
#endif

/************************************************************************/

void main(void)
{
int event;
	
	init_prog();

	menu_bar(adr_menu, 1);

	graf_mouse(ARROW, 0);

	dialogue(OPEN_DIAL);

	do		/* BOUCLE PRINCIPALE DU PROGRAMME */
	{

		event = get_evnt((MU_TIMER|MU_MESAG|MU_BUTTON|MU_KEYBD), 0L, 100);

		menu_keyshort(adr_menu, event, 0); /* Raccourcis Clavier des Menus. */

		if ((event & MU_MESAG) && buff[0] == MN_SELECTED)
		{
			switch (buff[4])
			{
			case MENU_INFOS :
				informe(OPEN_DIAL);
				break;
			case MENU_DIAL :
				dialogue(OPEN_DIAL);
				break;
			case MENU_QUIT :
				quit = 1;
				break;
			}
			menu_tnormal(adr_menu, buff[3], 1);
		}

		else if ( (event & MU_MESAG) && buff[0] == AP_TERM )	/* Nouveau */
    {
			quit = 1;
		}

		else
		{

/* *** Aiguillage en fonction du Handle : *** */

			if (buff[3] > 0)						/* Si W_Handle > 0 .... */
			{
				if (buff[3] == info_var.w_handle)
					informe(event);
				else if (buff[3] == dial_var.w_handle)
					dialogue(event);
			}
#ifdef DESK
			else
				desktop(event); /*...sinon gestion d'un objet sur le Bureau.*/
#endif
		}
	} while (quit == 0);

/*	Avant de quitter, fermeture des fenres ventuellement ouvertes, on peut
	aussi utiliser "wind_new()"	: */

	close_dialog(&info_var);
	close_dialog(&dial_var);

	menu_bar(adr_menu, 0);
	sauve_prefs();
	end_prog();
}

void end_prog(void)
{
#ifdef DESK
	wind_set (0, WF_NEWDESK, 0, 0); /* A mettre en permanence. */
#endif
	v_clsvwk(vdi_handle);
	v_clsvwk(aes_handle);
	rsrc_free();
	appl_exit();
	exit(0);
}

/************************************************************************/
/*	Quelques routines "Utilisateur" pour l'exemple :					*/
/************************************************************************/

void informe(int event)
{
	WINDFORM_VAR *ptr_var = &info_var;
	int choix;

	if (event == OPEN_DIAL)
	{
		set_editable(ptr_var, INFOS_VERSION,version,0);
		set_editable(ptr_var, INFOS_COMPILE,compilation,0);
		open_dialog(ptr_var, " Informations ", 0, TRUE);
	}
	else
	{
		choix = windform_do(ptr_var, event);
		if (choix != 0)
		{

			switch	(choix)
			{
				case CLOSE_DIAL :	/* Case de fermeture	*/
					close_dialog(ptr_var);

					break;
				case INFOS_OK :
					close_dialog(ptr_var);
					wf_change(ptr_var, choix, NORMAL, 0);
					break;
			}
		}
	}
}

void dialogue(int event)
{
	WINDFORM_VAR *ptr_var = &dial_var;
	int choix;

	if (event == OPEN_DIAL)
	{
		open_dialog(ptr_var, " Dialogue ", DIAL_EDIT , TRUE);
	}
	else
	{
		choix = windform_do(ptr_var, event);
		if (choix != 0)
		{
			switch(choix)
			{
				case CLOSE_DIAL :	/* Case de fermeture	*/
					close_dialog(ptr_var);
					break;
				case DIAL_BISTABLE :
					Cconout(7);					/* "Ping" */
					break;
				case DIAL_POP :
					pop_up(ptr_var, choix, POP_TEST); /* Gestion de ce pop-up */
					break;
				case DIAL_OK :
					close_dialog(ptr_var);
					wf_change(ptr_var, choix, NORMAL, 0);
					break;
			}
		}
	}
}


/************************************************************************/
/*	Routine d'initialisations du programme :							*/
/************************************************************************/

void init_prog(void)
{

	init_gem(); /* Nouveau pour Version 3.0 */

	get_prg_path(PRG);  /* Recherche rpertoire du Programme. */

	if (load_rsc(RSC, NO_WINDOW, ICONIF) == FALSE)
	{
		end_prog();
	}

	rsrc_gaddr(0, MENU, &adr_menu);

	open_inf(INF,"r"); /* Ouverture des INF en Lecture.	*/
	
	init_windform(&info_var, INFOS , 10, 10);
	init_windform(&dial_var, DIAL, 10, 10);
#ifdef DESK
	init_windesk(BUREAU);
#endif
	close_inf();
	
/* Exemple d'initialisations de champs de texte en dbut de programme : */

	set_editable(&dial_var,DIAL_EDIT,"Olivier",0);
}

void sauve_prefs(void)
{
	graf_mouse(BUSYBEE, 0);

	open_inf(INF,"w"); /* Ouverture des INF en Ecriture !	*/
	save_windform(&info_var);
	save_windform(&dial_var);
#ifdef DESK
	save_windesk();
#endif
	close_inf();

	graf_mouse(ARROW, 0);
}

#ifdef DESK
void desktop(int event)
{
	char essai[256];
	int choix;

	choix = windesk_do(event);
	if (desk_icon_selected != 0)
	{
		if (choix == desk_icon_selected)
		{
			form_alert(1, "[1][ WINFDEMO : | |"
							" Double_clic sur l'Icone. ][ OK ]");
		}
		else if (choix != 0)
		{
			sprintf(essai, "%s %d%s %d%s", "[1][   WINFDEMO : | |"
				" DRAG & DROP| de l'Icone d'index :", desk_icon_selected,
				"|sur l'Icone d'index :", choix, "][ OK ]");
			form_alert(1, essai);
		}
	}
}
#endif

/* ----- EOF ----- */
